



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>linux下如何使用gdb调试</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">linux下如何使用gdb调试</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-16 05:31:28 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>gdb是linux下非常好用的一个调试工具，虽然它是命令行模式的调试工具，但是它的功能强大到你无法想象，这里简单介绍下gdb下常用的命令。</p>
<p>首先编译生成可执行文件(这里的test.c是一个简单的求前n项和的程序)。</p>
<p>gcc -g test.c -o test（-g选项告诉gcc在编译程序时加入调试信息）。<br />接下来可以这样。</p>
<p>gdb test</p>
<p>然后你就会看到出现好多信息在屏幕上，大致说的是gdb的一些版本信息说明之类的，但是它对你调试程序没用呀，所以，你可以加上-q选项，不输出它们。</p>
<p>gdb -q test</p>
<div>
<pre class="prettyprint linenums">wang@king:~$ gdb -q test<br />
Reading symbols from test...done.<br />
(gdb) </pre>
</div>
<p>有没有觉得这个世界一下子清净了许多。</p>
<p>也可以先进入gdb模式，然后再加载文件。</p>
<div>
<pre class="prettyprint linenums">wang@king:~$ gdb -q<br />
(gdb) file test<br />
Reading symbols from test...done.<br />
(gdb) </pre>
</div>
<p>好了，现在开始调试了，但是我还想看看我的代码怎么办，gdb提供了一条命令，可以让你的程序显示出来。</p>
<div>
<pre class="prettyprint linenums">(gdb)                                       //list默认一次显示10行<br />
    #include&lt;stdio.h&gt;<br />
    int func(int n)<br />
    {<br />
        int i;<br />
        int sum=;<br />
        for(i=;i&lt;n;i++)<br />
            {<br />
                sum+=i;<br />
            }<br />
        return sum;<br />
(gdb)                                       //直接输入回车重复上次命令，显示接下来的10行<br />
    }<br />
    int main()<br />
    {<br />
        int n;<br />
        printf("请输入n的值");<br />
        scanf("%d",&amp;n);<br />
        printf("1+2+..+%d=%d",n,func(n));<br />
        return ;<br />
    }<br />
(gdb)
            </pre>
</div>
<p>list默认参数可以用show listsize来查看，如果感觉10行太多或者太少，还可以用set listsize &lt;count&gt;来更改。</p>
<p>list 还可以加上其他参数，比如：<br />list 5,10&nbsp;&nbsp; 显示第5行到第10行的代码；</p>
<p>list func&nbsp;&nbsp; 显示func函数周围的代码，显示范围和list参数有关；</p>
<p>list test.c:5,10&nbsp; 显示源文件test.c第5行到第10行的代码，一般用于调试含多个源文件的程序。</p>
<p>gdb 还支持字符串查找，search str，从当前行开始，向前查找含str的字符串；</p>
<p>reverse-search str，从当前行开始，向后查找含str的字符串。</p>
<p>现在你的屏幕应该被占满了吧？想清空屏幕，可是还在gdb里面呀，怎么办？其实，gdb也支持运行linux命令的，可以在gdb的提示符中，输入shell，然后在输入你需要的命令就可以了</p>
<div>
<pre class="prettyprint linenums">(gdb) shell clear</pre>
</div>
<p>这样也能达到清屏的效果。</p>
<p>看了程序的代码，感觉第6行代码可能有点问题，现在就需要我就需要设置一个断点，让程序停在第6行之前。</p>
<div>
<pre class="prettyprint linenums">(gdb) break<br />
Breakpoint  at 0x80484c8: file test.c, line .<br />
(gdb) </pre>
</div>
<p>下面一行的 信息，1说明我设置的这个断点是第一个断点，断点所在内存地址为0x80484c8，它在文件test.c的第6行。</p>
<p>gdb还可以以条件表达式设置断点。</p>
<div>
<pre class="prettyprint linenums">(gdb) break  if n==<br />
Breakpoint  at 0x80484d1: file test.c, line .<br />
(gdb) </pre>
</div>
<p>这个断点的含义是，如果n的值为6，则程序运行到第7行停止。</p>
<p>当然，还可以直接在某个函数处设置断点；直接break 函数名就可以了，</p>
<p>然后我们想看下设置的断点信息，可以使用info breakpoints命令。</p>
<div>
<pre class="prettyprint linenums">(gdb) info breakpoints<br />
Num     Type           Disp Enb Address    What<br />
       breakpoint     keep y   0x080484c8 in func at test.c:<br />
       breakpoint     keep y   0x080484d1 in func at test.c:<br />
    stop only if n==<br />
       breakpoint     keep y   0x080484c1 in func at test.c:<br />
(gdb) </pre>
</div>
<p>Num表示断点的编号；Type表示断点的断点的类型，第二个断点类型还加上了条件；Disp表示中断点在执行一次之后是否失去作用，dis为是，keep为不是；Enb表示当前中断点是否有效，y为是，n为否；Address表示中断点所处的内存地址；What指出断点所处的位置。</p>
<p>如果不需要程序在该断点暂停时，有两种方法，一种是使该断点失效，一种是直接删除该断点。</p>
<div>
<pre class="prettyprint linenums">(gdb) disable<br />
(gdb) info breakpoints<br />
Num     Type           Disp Enb Address    What<br />
       breakpoint     keep n   0x080484c8 in func at test.c:<br />
       breakpoint     keep y   0x080484d1 in func at test.c:<br />
    stop only if n==<br />
       breakpoint     keep y   0x080484c1 in func at test.c:<br />
(gdb) </pre>
</div>
<p>可以看到，第一个断点的Enb变为n了，表示该断点已经无效了，如果需要恢复，可以使用enable命令。这里需要注意的是，disable后面的参数为断点的编号。而不是行号。</p>
<p>直接删除该断点，可以使用clear命令和delete命令。</p>
<div>
<pre class="prettyprint linenums">(gdb) clear<br />
已删除的断点<br />
(gdb) </pre>
</div>
<p>clear命令后面的参数为设置断点的行号，clear后面参数还可以加设置断点的函数名。</p>
<p>delete命令后面的参数为断点的编号；可以一次删除多个断点，断点编号之间用空格隔开；如果delete后没有参数，默认删除所以断点，会给出提示选择是否操作。</p>
<div>
<pre class="prettyprint linenums">(gdb) delete<br />
删除所有断点吗？ (y or n) </pre>
</div>
<p>断点设置好了，现在就可以调试了，</p>
<div>
<pre class="prettyprint linenums">(gdb) run                                                //开始执行程序<br />
Starting program: /home/wang/test<br />
请输入n的值10

Breakpoint , func (n=) at test.c:     //设置的第一个断点，程序在第6行暂停<br />
        for(i=;i&lt;n;i++)<br />
(gdb) continue                                      //让程序继续运行，直到下个断点或者结束<br />
Continuing.

Breakpoint , func (n=) at test.c:    //第二个断点设置的是i==6时停止<br />
                sum+=i;<br />
(gdb) print i                                          //用print命令打印出i的值<br />
$ =<br />
(gdb) print sum<br />
$ =<br />
(gdb) next                                          //继续执行下一条语句，只执行一条。<br />
        for(i=;i&lt;n;i++)<br />
(gdb) next<br />
                sum+=i;<br />
(gdb) print i<br />
$ =<br />
(gdb) continue<br />
Continuing.<br />
++..+=[Inferior  (process ) exited normally]<br />
(gdb) quit                                             //退出gdb调试
                                            </pre>
</div>
<p>上面出现了很多命令，下面就来说说都是怎么用的。</p>
<p>run，开始运行程序；</p>
<p>continue，程序暂停时继续运行程序的命令；</p>
<p>print 变量名或表达式，打印该变量或者该表达式的值。whatis 变量名或者表达式，可以显示该变量或表达式的数据类型。</p>
<p>print&nbsp; 变量=值，这种形式还可以给对应的变量赋值；类似的还有set variable 变量=值。作用和用print赋值相同。</p>
<p>next，继续执行下一条语句；还有一条命令step，与之类似，不同的是，当下一条语句遇到函数调用的时候，next不会跟踪进入函数，而是继续执行下面的语句，而step命令则会跟踪进入函数内部。</p>
<div>
<pre class="prettyprint linenums">(gdb) run<br />
Starting program: /home/wang/test 

Breakpoint , main () at test.c:<br />
        scanf("%d",&amp;n);<br />
(gdb) next<br />
请输入n的值10<br />
        printf("1+2+..+%d=%d",n,func(n));<br />
(gdb) next                                             //next命令直接执行下一行，没有进入func函数<br />
        return ;<br />
(gdb)</pre>
</div>
<div>
<div>
<pre class="prettyprint linenums">(gdb) run<br />
Starting program: /home/wang/test 

Breakpoint , main () at test.c:<br />
        scanf("%d",&amp;n);<br />
(gdb) n<br />
请输入n的值10<br />
        printf("1+2+..+%d=%d",n,func(n));<br />
(gdb) step　　　　　　　　　　　　　　　　　　//step命令跟踪进入了func函数　　<br />
func (n=) at test.c:<br />
        int sum=;<br />
(gdb) </pre>
</div>
<pre class="prettyprint linenums"></pre>
</div>
<p>还有nexti和stepi命令，这两个是单步执行一条机器指令，比如(i=0;i&lt;n;i++)这条语句需要输入多个nexti才能执行完；两个的区别和上面相同。</p>
<p>quit，退出gdb调试，如果调试中想要退出，可以直接输入该命令，会出现提示选择是否退出。kill命令，结束当前程序的调试，（不会退出gdb）。</p>
<div>
<pre class="prettyprint linenums">(gdb) quit<br />
A debugging session is active.

    Inferior  [process ] will be killed.

Quit anyway? (y or n) </pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q7mkmjq.html">【ASP&period;NET程序员福利】打造一款人见人爱的ORM（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jde449.html">Nutch源码阅读进程2---Generate</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qn05xx9.html">轻快的VIM（三）：删除</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq12dz69.html">poj1379    模拟退火</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql22008.html">phpcms更换域名&vert;&vert;外网访问本地网站</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8ke35j8.html">帅呆了！ASP&period;NET Core每秒能处理115万个请求</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pznxz8.html">JavaScriptSerializer中日期序列化问题解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xjrj09.html">Tomcat运行DOM4J的时候报ClassNotFoundException</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0nkg4q.html">Codeforces Round &num;335 &lpar;Div&period; 1&rpar; C&period; Freelancer&amp;&num;39&semi;s Dreams 计算几何</a>
		</li>
						<li><a href="https://www.batexi.com/a/96okryn9.html">IP 碎片重组</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z6le09.html">使用开源软件sentry来收集日志</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y0d75q.html">java&period;lang&period;OutOfMemoryError&colon; Java heap space错误及处理办法&lpar;收集整理、转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mk4lgq.html">禁止 favicon&period;ico 请求</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o16kj9.html">理解TCP为什么需要进行三次握手</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o6lkn9.html">windows下搭建python&plus;selenium环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpk6p39.html">angular 时间戳转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj7k119.html">Spark性能调优之JVM调优</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m22zg2q.html">Struts2框架&lpar;4&rpar;---Action类访问servlet</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyrwkdq.html">C&plus;&plus; 类中特殊的成员变量（常变量、引用、静态）的初始化方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdmvej9.html">python --- 18     类与类之间的关系&comma; 特殊成员</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9r530wdq.html">流媒体技术学习笔记之（十七）FFmpeg 3&period;3《希尔伯特》-新版本的亮点</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gj05x79.html">Newtonsoft&period;Json 两个Attribute含义</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvergk8.html">用Python中的re做信息筛选</a>
			</li>
						<li><a href="https://www.batexi.com/a/960kdon9.html">MyBatis全局配置文件MyBatis-config&period;xml代码</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e47w7e9.html">实现一个string类</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjlke79.html">POJ1251 Jungle Roads【最小生成树】</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e473dj9.html">阿里云3台机器搭建Hadoop HA服务</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnvk4m38.html">&lbrack;HAOI2018&rsqb;奇怪的背包 （DP，数论）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rnd2z8.html">SpringBoot2&period;x过滤器Filter和使用Servlet3&period;0配置自定义Filter实战</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjl6mj9.html">volatile的深入理解--【sky原创】</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
